<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Markup/RST.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Markup/RST.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Markup/RST.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Markup <span class="py-keyword">import</span> *</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> docutils.nodes <span class="py-keyword">import</span> *</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> docutils.core <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> docutils.parsers.rst <span class="py-keyword">import</span> roles</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">import</span> re, StringIO</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/RST/SummaryExtractor.html">SummaryExtractor</a>(NodeVisitor):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A SummaryExtractor creates a document containing the first sentence of</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">    a source document.&quot;&quot;&quot;</span></span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/RST/SummaryExtractor.html#__init__">__init__</a>(self, document):</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">        NodeVisitor.__init__(self, document)</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">        self.summary = None</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/RST/SummaryExtractor.html#visit_paragraph">visit_paragraph</a>(self, node):</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Copy the paragraph but only keep the first sentence.&quot;&quot;&quot;</span></span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">        <span class="py-keyword">if</span> self.summary <span class="py-keyword">is</span> <span class="py-keyword">not</span> None:</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">        summary_pieces = []</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        <span class="py-comment"># Extract the first sentence.</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">        <span class="py-keyword">for</span> child <span class="py-keyword">in</span> node:</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">            <span class="py-keyword">if</span> isinstance(child, Text):</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">                m = re.match(<span class="py-string">r'(\s*[\w\W]*?\.)(\s|$)'</span>, child.data)</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">                <span class="py-keyword">if</span> m:</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">                    summary_pieces.append(Text(m.group(1)))</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">                    <span class="py-keyword">break</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">                    summary_pieces.append(Text(child))</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">                summary_pieces.append(child)</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        self.summary = self.document.copy()</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">        para = node.copy()</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        para[:] = summary_pieces</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        self.summary[:] = [para]</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/RST/SummaryExtractor.html#unknown_visit">unknown_visit</a>(self, node):</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-string">'Ignore all unknown nodes'</span></span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/RST/RST.html">RST</a>(Formatter):</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Format summary and detail documentation according to restructured text markup.</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Markup/RST/RST.html#format">format</a>(self, decl, view):</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        formatter = self</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        <span class="py-keyword">def</span> ref(name, rawtext, text, lineno, inliner,</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">                options={}, content=[]):</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">            name = utils.unescape(text)</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">            uri = formatter.lookup_symbol(name, decl.name[:-1])</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">            <span class="py-keyword">if</span> uri:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">                ref = rel(view.filename(), uri)</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">                node = reference(rawtext, name, refuri=ref, **options)</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">                node = emphasis(rawtext, name)</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">            <span class="py-keyword">return</span> [node], []</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">        roles.register_local_role(<span class="py-string">''</span>, ref)</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        errstream = StringIO.StringIO()</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        settings = {}</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        settings[<span class="py-string">'halt_level'</span>] = 2</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        settings[<span class="py-string">'warning_stream'</span>] = errstream</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        settings[<span class="py-string">'traceback'</span>] = True</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        doc = decl.annotations.get(<span class="py-string">'doc'</span>)</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        <span class="py-keyword">if</span> doc:</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">            <span class="py-keyword">try</span>:</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">                doctree = publish_doctree(doc.text, settings_overrides=settings)</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">                <span class="py-comment"># Extract the summary.</span></span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">                extractor = SummaryExtractor(doctree)</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">                doctree.walk(extractor)</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">                reader = docutils.readers.doctree.Reader(parser_name=<span class="py-string">'null'</span>)</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">                <span class="py-comment"># Publish the summary.</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">                <span class="py-keyword">if</span> extractor.summary:</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">                    pub = Publisher(reader, None, None,</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">                                    source=io.DocTreeInput(extractor.summary),</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">                                    destination_class=io.StringOutput)</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                    pub.set_writer(<span class="py-string">'html'</span>)</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                    pub.process_programmatic_settings(None, None, None)</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                    dummy = pub.publish(enable_exit_status=None)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                    summary = pub.writer.parts[<span class="py-string">'html_body'</span>]</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">                    <span class="py-comment"># Hack to strip off some redundant blocks to make the output</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line">                    <span class="py-comment"># more compact.</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">                    <span class="py-keyword">if</span> (summary.startswith(<span class="py-string">'&lt;div class=&quot;document&quot;&gt;\n'</span>) <span class="py-keyword">and</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line">                        summary.endswith(<span class="py-string">'&lt;/div&gt;\n'</span>)):</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                        summary=summary[23:-7]</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">                    summary = <span class="py-string">''</span></span>
<a id="line112"></a><span class="lineno">112</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">                <span class="py-comment"># Publish the details.</span></span>
<a id="line114"></a><span class="lineno">114</span><span class="line">                pub = Publisher(reader, None, None,</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">                                source=io.DocTreeInput(doctree),</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">                                destination_class=io.StringOutput)</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">                pub.set_writer(<span class="py-string">'html'</span>)</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">                pub.process_programmatic_settings(None, None, None)</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">                dummy = pub.publish(enable_exit_status=None)</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">                details = pub.writer.parts[<span class="py-string">'html_body'</span>]</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">                <span class="py-comment"># Hack to strip off some redundant blocks to make the output</span></span>
<a id="line122"></a><span class="lineno">122</span><span class="line">                <span class="py-comment"># more compact.</span></span>
<a id="line123"></a><span class="lineno">123</span><span class="line">                <span class="py-keyword">if</span> (details.startswith(<span class="py-string">'&lt;div class=&quot;document&quot;&gt;\n'</span>) <span class="py-keyword">and</span></span>
<a id="line124"></a><span class="lineno">124</span><span class="line">                    details.endswith(<span class="py-string">'&lt;/div&gt;\n'</span>)):</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">                    details=details[23:-7]</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">                <span class="py-keyword">return</span> Struct(summary, details)</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">            <span class="py-keyword">except</span> docutils.utils.SystemMessage, error:</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">                xx, line, message = str(error).split(<span class="py-string">':'</span>, 2)</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'In DocString attached to declaration at %s:%d:'</span>%(decl.file.name,</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">                                                                        decl.line)</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'  line %s:%s'</span>%(line, message)</span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        <span class="py-keyword">return</span> Struct(<span class="py-string">''</span>, <span class="py-string">''</span>)</span>
<a id="line136"></a><span class="lineno">136</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
